function [vecQuatTranArray, sqrtEigenValues, vol] = AxisAlignMesh( pMesh, kMesh )

%create 4 rigid body transforms to align an object with the axes
%The first rbt considers ensures 3rd order moments M300 and M030 are
%positive
%2nd M300 positive M030 negative
%3rd M300 negative M030 positive
%4th M300 negative M030 negative

[vol, theCentroid, sqrtEigenValues, eigenVectors, covMat, caliperVec] = MeshProperties( pMesh, kMesh, 0 );


RbtAlign = eye(4);
RbtAlign(1:3,4) = -theCentroid; %to move centroid to the origin    
RbtAlign = [inv(eigenVectors), [0;0;0];[0,0,0,1]] * RbtAlign;

[M300, M030, M003, vol1] = MeshThirdMoments( inv(eigenVectors) * CoordAdd( pMesh, -theCentroid ), kMesh );

if M003 < 0,   RbtAlign = [rotmatrix(0,180,0), [0;0;0];[0,0,0,1]] * RbtAlign;  end        
if M030 < 0,   RbtAlign = [rotmatrix(180,0,0), [0;0;0];[0,0,0,1]] * RbtAlign; ;  end

vecQuatTranArray(:,1) = Matrix4x4ToQuatTran( RbtAlign );

RbtAlign2 = ([rotmatrix(180,0,0), [0;0;0];[0,0,0,1]]) * RbtAlign;
vecQuatTranArray(:,2) = Matrix4x4ToQuatTran( RbtAlign2 );

RbtAlign3 = ([rotmatrix(0,180,0), [0;0;0];[0,0,0,1]]) * RbtAlign;
vecQuatTranArray(:,3) = Matrix4x4ToQuatTran( RbtAlign3 );

RbtAlign4 = ([rotmatrix(180,0,0), [0;0;0];[0,0,0,1]]) * ([rotmatrix(0,180,0), [0;0;0];[0,0,0,1]]) * RbtAlign;
vecQuatTranArray(:,4) = Matrix4x4ToQuatTran( RbtAlign4 );

% if M300 < 0,   RbtAlign = [rotmatrix(0,180,0), [0;0;0];[0,0,0,1]] * RbtAlign;  end        
% if M030 < 0,   RbtAlign = [rotmatrix(0,0,180), [0;0;0];[0,0,0,1]] * RbtAlign; ;  end
% 
% vecQuatTranArray(:,1) = Matrix4x4ToQuatTran( RbtAlign );
% 
% RbtAlign2 = ([rotmatrix(0,0,180), [0;0;0];[0,0,0,1]]) * RbtAlign;
% vecQuatTranArray(:,2) = Matrix4x4ToQuatTran( RbtAlign2 );
% 
% RbtAlign3 = ([rotmatrix(0,180,0), [0;0;0];[0,0,0,1]]) * RbtAlign;
% vecQuatTranArray(:,3) = Matrix4x4ToQuatTran( RbtAlign3 );
% 
% RbtAlign4 = ([rotmatrix(0,0,180), [0;0;0];[0,0,0,1]]) * ([rotmatrix(0,180,0), [0;0;0];[0,0,0,1]]) * RbtAlign;
% vecQuatTranArray(:,4) = Matrix4x4ToQuatTran( RbtAlign4 );
