function [mergedViewVec, pixRmsAcross, relPose] = MergeViewVec( viewVecA, viewVecB, relPose )

%[mergedViewVec, pixRmsAcross] = MergeViewVec( viewVecA, viewVecB ) --
%compute relative pose and merge
%
%[mergedViewVec, pixRmsAcross] = MergeViewVec( viewVecA, viewVecB, relPose) -- merge from known relative pose

if not(exist('relPose'))
    quatVec = SlerpedQuaternionGridSet(4); %orientation starting points
    mfe = 12;
    tol = 1e-3;
    [pixRmsAcross, rmsOrthoResOpt, relPose] = MultiStartPoseOpt( viewVecA, viewVecB, quatVec, mfe, tol );
end


if length(relPose(:)) == 7 
    relPose = QuatTranToMatrix4x4( relPose );
end

ensure('all(size(relPose)==[4,4])');

mergedViewVec = viewVecA;

for viewLoop = 1:length(viewVecB),
    
    
    viewVecB(viewLoop).camera.pose = inv( relPose * inv(viewVecB(viewLoop).camera.pose) );
    mergedViewVec(end+1) = viewVecB(viewLoop);
    
    
end