function [vol, theCentroid, sqrtEigenValues, eigenVectors, covMat, caliperVec] = MeshProperties( pMesh, kMesh, draw )


%[vol, theCentroid, sqrtEigenValues, eigenVectors, covMat] = MeshProperties( pMesh, kMesh, draw )
%Use   pMesh = inv(eigenVectors)*pMesh to align the visual hull with the axes;

ensure('3==size(pMesh,1)') %3D points

if not(exist('draw'))
    draw = 0;
end



%if 0
T2 =  pMesh(1, kMesh(1, :) ) .* ...
    (  pMesh(3, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) ) - ...
    pMesh(2, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) )   ) + ...
    pMesh(2, kMesh(1, :) ) .* ...
    (  pMesh(1, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) ) - ...
    pMesh(3, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) )   ) + ...
    pMesh(3, kMesh(1, :) ) .* ...
    (  pMesh(2, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) ) - ...
    pMesh(1, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) )   ) ;

% else
%     
% T2 =  pMesh(1, kMesh(1, :) ) .* ...
%     (  -pMesh(3, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) ) + ...
%     pMesh(2, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) )   ) + ...
%     pMesh(2, kMesh(1, :) ) .* ...
%     (  -pMesh(1, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) ) + ...
%     pMesh(3, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) )   ) + ...
%     pMesh(3, kMesh(1, :) ) .* ...
%     (  -pMesh(2, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) ) + ...
%     pMesh(1, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) )   ) ;
%     
% end

vol =  sum(T2)/6;

if vol < 0
    error('negative volume -- perhaps reorder mesh triangles with flipud(kMesh)')
end

%T2
%x0 = sum( T2 .* (pMesh(1, kMesh(1,:) ) + pMesh(1, kMesh(2,:) ) + pMesh(1, kMesh(3,:)) ) )/(24*vol)

x0 = sum( T2 .* (pMesh(1, kMesh(1,:) ) + pMesh(1, kMesh(2,:) ) + pMesh(1, kMesh(3,:)) ) )/(24*vol);
y0 = sum( T2 .* (pMesh(2, kMesh(1,:) ) + pMesh(2, kMesh(2,:) ) + pMesh(2, kMesh(3,:)) ) )/(24*vol);
z0 = sum( T2 .* (pMesh(3, kMesh(1,:) ) + pMesh(3, kMesh(2,:) ) + pMesh(3, kMesh(3,:)) ) )/(24*vol);
theCentroid = [x0;y0;z0];


Ixx = sum ( T2 .* (...
    pMesh(1, kMesh(1, :)).^2 + ...
    pMesh(1, kMesh(2, :)).^2 + ...
    pMesh(1, kMesh(3, :)).^2 + ...
    pMesh(1, kMesh(1, :)) .* pMesh(1, kMesh(2, :)) +...
    pMesh(1, kMesh(2, :)) .* pMesh(1, kMesh(3, :)) +...
    pMesh(1, kMesh(3, :)) .* pMesh(1, kMesh(1, :)) ) )  / 60;

Iyy = sum ( T2 .* (...
    pMesh(2, kMesh(1, :)).^2 + ...
    pMesh(2, kMesh(2, :)).^2 + ...
    pMesh(2, kMesh(3, :)).^2 + ...
    pMesh(2, kMesh(1, :)) .* pMesh(2, kMesh(2, :)) +...
    pMesh(2, kMesh(2, :)) .* pMesh(2, kMesh(3, :)) +...
    pMesh(2, kMesh(3, :)) .* pMesh(2, kMesh(1, :)) ) )  / 60;

Izz = sum ( T2 .* (...
    pMesh(3, kMesh(1, :)).^2 + ...
    pMesh(3, kMesh(2, :)).^2 + ...
    pMesh(3, kMesh(3, :)).^2 + ...
    pMesh(3, kMesh(1, :)) .* pMesh(3, kMesh(2, :)) +...
    pMesh(3, kMesh(2, :)) .* pMesh(3, kMesh(3, :)) +...
    pMesh(3, kMesh(3, :)) .* pMesh(3, kMesh(1, :)) ) )  / 60;


Ixy =   sum ( T2.*(...
    2 * pMesh(1, kMesh(1, :)) .* pMesh(2, kMesh(1, :)) +...
    2 * pMesh(1, kMesh(2, :)) .* pMesh(2, kMesh(2, :)) +...
    2 * pMesh(1, kMesh(3, :)) .* pMesh(2, kMesh(3, :)) +...
    1 * pMesh(1, kMesh(1, :)) .* pMesh(2, kMesh(2, :)) +...
    1 * pMesh(1, kMesh(2, :)) .* pMesh(2, kMesh(3, :)) +...
    1 * pMesh(1, kMesh(3, :)) .* pMesh(2, kMesh(1, :)) +...
    1 * pMesh(1, kMesh(1, :)) .* pMesh(2, kMesh(3, :)) +...
    1 * pMesh(1, kMesh(2, :)) .* pMesh(2, kMesh(1, :)) +...
    1 * pMesh(1, kMesh(3, :)) .* pMesh(2, kMesh(2, :)) )) /120;

Ixz =   sum ( T2.*(...
    2 * pMesh(1, kMesh(1, :)) .* pMesh(3, kMesh(1, :)) +...
    2 * pMesh(1, kMesh(2, :)) .* pMesh(3, kMesh(2, :)) +...
    2 * pMesh(1, kMesh(3, :)) .* pMesh(3, kMesh(3, :)) +...
    1 * pMesh(1, kMesh(1, :)) .* pMesh(3, kMesh(2, :)) +...
    1 * pMesh(1, kMesh(2, :)) .* pMesh(3, kMesh(3, :)) +...
    1 * pMesh(1, kMesh(3, :)) .* pMesh(3, kMesh(1, :)) +...
    1 * pMesh(1, kMesh(1, :)) .* pMesh(3, kMesh(3, :)) +...
    1 * pMesh(1, kMesh(2, :)) .* pMesh(3, kMesh(1, :)) +...
    1 * pMesh(1, kMesh(3, :)) .* pMesh(3, kMesh(2, :)) )) /120;

Iyz =   sum ( T2.*(...
    2 * pMesh(2, kMesh(1, :)) .* pMesh(3, kMesh(1, :)) +...
    2 * pMesh(2, kMesh(2, :)) .* pMesh(3, kMesh(2, :)) +...
    2 * pMesh(2, kMesh(3, :)) .* pMesh(3, kMesh(3, :)) +...
    1 * pMesh(2, kMesh(1, :)) .* pMesh(3, kMesh(2, :)) +...
    1 * pMesh(2, kMesh(2, :)) .* pMesh(3, kMesh(3, :)) +...
    1 * pMesh(2, kMesh(3, :)) .* pMesh(3, kMesh(1, :)) +...
    1 * pMesh(2, kMesh(1, :)) .* pMesh(3, kMesh(3, :)) +...
    1 * pMesh(2, kMesh(2, :)) .* pMesh(3, kMesh(1, :)) +...
    1 * pMesh(2, kMesh(3, :)) .* pMesh(3, kMesh(2, :)) )) /120;


%        ii =  pMesh(1, kMesh(1, :)).^2 + ...
%         pMesh(1, kMesh(2, :)).^2 + ...
%         pMesh(1, kMesh(3, :)).^2 +...
%         pMesh(1, kMesh(1, faceLoop)) .* pMesh(1, kMesh(2, :)) +...
%            pMesh(1, kMesh(2, faceLoop)) .* pMesh(1, kMesh(3, :)) +...
%            pMesh(1, kMesh(3, faceLoop)) .* pMesh(1, kMesh(1, :));  
%        


covMat = [Ixx - vol * theCentroid(1)^2, ...   
        Ixy - vol * prod(theCentroid([1,2])), ...
        Ixz - vol * prod(theCentroid([1,3])); ...
        Ixy - vol * prod(theCentroid([1,2])),...
        Iyy - vol * theCentroid(2)^2, ...
        Iyz - vol * prod(theCentroid([2,3])); ...
        Ixz - vol * prod(theCentroid([1,3])),  ...
        Iyz - vol * prod(theCentroid([2,3])), ...
        Izz - vol * theCentroid(3)^2 ];
    
    
    [eigenVectors, eigenValues] = eig(covMat);
    
    if det(eigenVectors) < 0
        eigenVectors(:,3) = - eigenVectors(:,3);
    end
        
    
    eigenValues = diag(eigenValues);
    sqrtEigenValues = sqrt(eigenValues);
    
    
    pMeshAlign = inv(eigenVectors)*pMesh;
    
    for dim = 1:3,
        caliperVec(dim) = max( pMeshAlign(dim,:) ) - min( pMeshAlign(dim,:) );
    end
    
    %     
    %   for faceLoop = 1:size(kMesh, 2),
    %       polySoup{faceLoop} = aug(pMesh(:, kMesh(:,faceLoop) ));
    %   end
    %     
    %      [II, vv, cen] = msPolySoupSolidInertiaTensor( polySoup );
    
    
    
    if draw > 0
        NewFigure3D('renderer','opengl'), 
        patch('Faces', kMesh', 'Vertices', pMesh', 'EdgeColor', 'none', 'FaceColor', [0.9,1,1]*.8, 'FaceAlpha', 0.63)
        
        rad = 0.1 * vol^(1/3);
        PlotSphere(theCentroid, rad, 3, 'w'), fgcf
        
        for dim = 1:3,
            bottomRadiusCone = rad * 1.3;
            coneLength = 2*rad;
            
            mult = 4.67*sqrtEigenValues(dim).^(2/5);
            set( MyArrow( theCentroid, theCentroid+mult*eigenVectors(:,dim), rad, bottomRadiusCone, coneLength  ), ...
                'EdgeColor', 'none', 'FaceColor', MyPalette(dim) );
        end
        
        cameratoolbar togglescenelight 
    end
    
    
    %save