function [M300, M030, M003, vol] = MeshThirdMoments( pMesh, kMesh )

% See Appendix of EFFICIENT FEATURE EXTRACTION FOR 2D/3D OBJECTS IN MESH REPRESENTATION
% by Cha Zhang and Tsuhan Chen

ensure('3==size(pMesh,1)') %3D points
ensure('3==size(kMesh,1)') 


T =  pMesh(1, kMesh(1, :) ) .* ...
    (  pMesh(3, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) ) - ...
    pMesh(2, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) )   ) + ...
    pMesh(2, kMesh(1, :) ) .* ...
    (  pMesh(1, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) ) - ...
    pMesh(3, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) )   ) + ...
    pMesh(3, kMesh(1, :) ) .* ...
    (  pMesh(2, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) ) - ...
    pMesh(1, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) )   ) ;


% T2 =  pMesh(1, kMesh(1, :) ) .* ...
%     (  -pMesh(3, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) ) + ...
%     pMesh(2, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) )   ) + ...
%     pMesh(2, kMesh(1, :) ) .* ...
%     (  -pMesh(1, kMesh(3, :) ) .* pMesh(3, kMesh(2, :) ) + ...
%     pMesh(3, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) )   ) + ...
%     pMesh(3, kMesh(1, :) ) .* ...
%     (  -pMesh(2, kMesh(3, :) ) .* pMesh(1, kMesh(2, :) ) + ...
%     pMesh(1, kMesh(3, :) ) .* pMesh(2, kMesh(2, :) )   ) ;
% 
% 
% T =T2;

vol =  sum(T)/6;

for dim = 1:3,
%save
 M{dim} = sum ( T .* (...
    pMesh(dim, kMesh(1, :)).^3 + ...
    pMesh(dim, kMesh(2, :)).^3 + ...
    pMesh(dim, kMesh(3, :)).^3 + ...
    pMesh(dim, kMesh(1, :)).^2 .* ( pMesh(dim, kMesh(2, :)) + pMesh(dim, kMesh(3, :)) ) + ...
    pMesh(dim, kMesh(2, :)).^2 .* ( pMesh(dim, kMesh(3, :)) + pMesh(dim, kMesh(1, :)) ) + ...
    pMesh(dim, kMesh(3, :)).^2 .* ( pMesh(dim, kMesh(1, :)) + pMesh(dim, kMesh(2, :)) ) + ...
    pMesh(dim, kMesh(1, :)) .* pMesh(dim, kMesh(2, :)) .* pMesh(dim, kMesh(3, :)) ) )  / (6*20);
end


M300  = M{1};
M030  = M{2}; 
M003  = M{3};




