function vOut = Slerp( v1, v2, a)


% //!-------------------spherical linear interpolation---------------------------//
% MSLVector Sample::LinearInterpolate(MSLVector x1, MSLVector x2, double a){
%   
%   MSLVector v = MSLVector (4);
%   double cosTheta = x1[0]*x2[0] + x1[1]*x2[1] + x1[2]*x2[2] + x1[3]*x2[3];
%   double Theta = acos(cosTheta);
%     
%   double k1 = sin((1 - a)*Theta)/sin(Theta);
%   double k2 = sin(a*Theta)/sin(Theta);
%   v[0] = k1*x1[0] + k2*x2[0];
%   v[1] = k1*x1[1] + k2*x2[1];
%   v[2] = k1*x1[2] + k2*x2[2];
%   v[3] = k1*x1[3] + k2*x2[3];
%   return v;
% }


cosTheta = dot(v1,v2);
theta = acos(cosTheta);

k1 = sin((1 - a)*theta)/sin(theta);
k2 = sin(a*theta)/sin(theta);

vOut = k1*v1 + k2*v2;
