function sphereMat = SlerpedQuaternionGridSet( samplesPerAxis )


axisSamples = .5/samplesPerAxis + (0:(samplesPerAxis-1))/samplesPerAxis; %somewhere between 0 to 1


cube = [[+1;+1;+1], [-1;+1;+1], [-1;-1;+1], [+1;-1;+1], [+1;+1;-1], [-1;+1;-1], [-1;-1;-1], [+1;-1;-1] ];

cubeCell{1} = [ones(1,8); cube];
cubeCell{2} = [cube(1,:); ones(1,8); cube(2:3,:)];
cubeCell{3} = [cube(1:2,:); ones(1,8); cube(3,:)];
cubeCell{4} = [cube; ones(1,8)];

for cubeLoop = 1:length(cubeCell),
    cubeCell{cubeLoop} = cubeCell{cubeLoop}./repmat( sum(cubeCell{cubeLoop}.^2).^.5, 4, 1);
    %cube corners live on the unit hypersphere
end


sphereMat = [];
for cubeLoop = 1:length(cubeCell),
    
    for xLoop = 1:length(axisSamples),
        
        x1 = Slerp( cubeCell{cubeLoop}(:,1),  cubeCell{cubeLoop}(:,2), axisSamples(xLoop) );
        x2 = Slerp( cubeCell{cubeLoop}(:,4),  cubeCell{cubeLoop}(:,3), axisSamples(xLoop) );
        x3 = Slerp( cubeCell{cubeLoop}(:,5),  cubeCell{cubeLoop}(:,6), axisSamples(xLoop) );
        x4 = Slerp( cubeCell{cubeLoop}(:,8),  cubeCell{cubeLoop}(:,7), axisSamples(xLoop) );
        
        for yLoop = 1:length(axisSamples),                
            y1 =  Slerp(x1,x2, axisSamples(yLoop));
            y2 = Slerp(x3,x4, axisSamples(yLoop));
            
            for zLoop = 1:length(axisSamples),                
                sphereMat = [sphereMat, Slerp(y1,y2, axisSamples(zLoop)) ];
            end
            
        end        
    end    
end

