function [resVec, theCameraVec, allViews, normalAngle] = StaticMirrorCameraMovingObjErr( vec, vecScl, polyBoundaryVecCell )

vec = vec .* vecScl;
numImages = length(polyBoundaryVecCell);
ensure('5+4==length(vec)')
normalAngle = vec(end-3);
efl = vec(end-2);
p0 = [vec(end-1);vec(end)];
R = [cos(normalAngle) -sin(normalAngle) 0; sin(normalAngle) cos(normalAngle) 0; 0 0 1]; %rotate about Z-axis

m1Base =     [1;0;0];
m2Base = R * [1;0;0];

allViews.camera.efl = efl;
allViews.camera.u0 = p0(1);
allViews.camera.v0 = p0(2);
allViews.camera.kappa1 = 0;

wSoln = vec(1);
quat  = vec( 2:5 );    

RR = QuaternionToRotationMatrix(quat);
m1Hat = RR * m1Base;       
m2Hat = RR * m2Base;
M1_pos = -m1Hat;
M2_pos = -m2Hat * wSoln;

for viewLoop = 1:5,
    viewVec(viewLoop).camera = allViews.camera;
end

viewVec(1).camera.pose = eye(4);
viewVec(2).camera.pose = ReflectionMatrixFromVecPoint( m1Hat, M1_pos ) * viewVec(1).camera.pose ;
viewVec(3).camera.pose = ReflectionMatrixFromVecPoint( m2Hat, M2_pos ) * viewVec(1).camera.pose ;
viewVec(4).camera.pose = ReflectionMatrixFromVecPoint( m1Hat, M1_pos ) * viewVec(3).camera.pose ;
viewVec(5).camera.pose = ReflectionMatrixFromVecPoint( m2Hat, M2_pos ) * viewVec(2).camera.pose ;


resVec = [];

for imgLoop = 1:numImages,  
    
    for viewLoop = 1:5,
        viewVec(viewLoop).boundary = polyBoundaryVecCell{imgLoop}{viewLoop};
    end
%    resVec = [ resVec; PixelEtcErrForImageSet( viewVec )  ];
        resVec = [ resVec, PixelEtErrMex( viewVec )  ];
    
    
end

for viewLoop = 1:5,
theCameraVec(viewLoop) = viewVec(viewLoop).camera;
end