function [vecOpt, rmsErr, rmsVec] = VemhEtAlign( viewVecA, viewVecB, varargin )

numAlignments = 4;
doScale = 0;
VararginModifyDefaults(varargin{:});

%%%%%%%%%%%%%%%%%%%%%%%%%
%Example Usage:
%[vecOpt, rmsErr, rmsVec] = VemhEtAlign( viewVecCell{1}, viewVecCell{2}, 'doScale', 1 )

viewVecCell{1} = viewVecA;
viewVecCell{2} = viewVecB;


for runLoop = 1:2,    
    [vePointsStart, vePointsEnd] = ConvViewingEdgesMex(  viewVecCell{runLoop} );             
    vemhPoints = (vePointsStart+vePointsEnd)/2;        
    pMesh = vemhPoints;
    
    
    [kMesh, volVec(runLoop)] = convhulln(pMesh');        
    kMesh = flipud( kMesh');        
    
    if ( 2 == runLoop ) & ( doScale > 0)
        scale = (volVec(1) / volVec(2)) ^ (1/3);
        pMesh = pMesh * scale;
    end
    
    vecQuatTranArrayCell{runLoop} = AxisAlignMesh( pMesh, kMesh );    
end


bestErr = inf;
for alignLoop = 1:numAlignments,
    
    vecMoment = Matrix4x4ToQuatTran( ...
        inv(  QuatTranToMatrix4x4( vecQuatTranArrayCell{1}(:,1) )  ) * ...
        QuatTranToMatrix4x4( vecQuatTranArrayCell{2}(:,alignLoop) ) );
    
    
    if ( doScale > 0)
        
        
        vecMoment = [vecMoment; scale * ones(size(vecMoment,2))];
        [pixRmsPersp, vecPerspOpt] = MultiStartScalePerspPoseOpt(viewVecCell{1}, viewVecCell{runLoop}, vecMoment );
        
        
    else
        
        [pixRmsPersp, vecPerspOpt] = MultiStartPerspPoseOpt(viewVecCell{1}, viewVecCell{runLoop}, vecMoment );
        
    end
    
    rmsVec(alignLoop) = pixRmsPersp;
    
    if pixRmsPersp < bestErr
        bestErr = pixRmsPersp;
        vecOpt = vecPerspOpt;
    end
    
    
    
end

rmsErr = bestErr;