function R=rotmatrix(yawdeg,pitchdeg,rolldeg)

%as in Corel Dream 3D
%right handed axes
%  |z
%x/\y


%The yaw, pitch and roll angles define a rotation about the
%$X$-axis by the roll angle $\gamma$, followed by a rotation about
%the $Y$-axis by the pitch angle $\beta$, followed by a rotation
%about the $Z$-axis by the yaw angle $\alpha$.


yaw=yawdeg*pi/180;
pitch=pitchdeg*pi/180;
roll=rolldeg*pi/180;

mat1=[cos(yaw) -sin(yaw) 0; sin(yaw) cos(yaw) 0; 0 0 1]; %rotate about Z-axis
mat2=[cos(pitch) 0 sin(pitch); 0 1 0; -sin(pitch) 0 cos(pitch)]; %rotate about Y-axis
mat3=[1 0 0; 0 cos(roll) -sin(roll); 0 sin(roll) cos(roll)]; %rotate about X-axis

R=mat1*mat2*mat3;




